# frozen_string_literal: true

#
# @summary Filter the list of controls based on the which database it will be applied to
#
#
# See the file "LICENSE" for the full license governing this code.
#
Puppet::Functions.create_function('db2_secured::filter_controls') do
  dispatch :filter_controls do
    param 'String[1]',                  :title
    param 'Hash[String[1], String[1]]', :controls
  end

  def filter_controls(_title, controls)
    controls
  end
end
