# frozen_string_literal: true

#
# @summary Create a random id based on letters.
#
# See the file "LICENSE" for the full license governing this code.
#
Puppet::Functions.create_function('db2_secured::random_id') do
  dispatch :random_id do
    param 'Integer', :length
    # return_type 'Boolean' TODO: Wait until the Puppet version supporting this, is mainstream
  end

  def random_id(length = 6)
    random_letter(length)
  end

  def random_letter(length = 1)
    (('A'..'Z').to_a + ('a'..'z').to_a).sort_by { rand }.join[0...length]
  end
end
