#
# See the file "LICENSE" for the full license governing this code.
#
#
# Revoke public grants to the specfied resources
#
#
define db2_secured::internal::revoke_right (
  Array[String[1]] $user_list,
  Array[String[1]] $group_list
) {
  $elements = $title.split('/')
  $instance = $elements[0]
  $database = $elements[1]
  $right    = $elements[2]

  if  $facts["db2_${right}_grantees"] {
    $users_to_revoke = $facts["db2_${right}_grantees"].filter |$data| {
      $data['instance'] == $instance and $data['database'] == $database and $data['type'] == 'U'
    }.map |$e| { $e['name'] } - [$instance.upcase]

    $groups_to_revoke = $facts["db2_${right}_grantees"].filter |$data| {
      $data['instance'] == $instance and $data['database'] == $database and $data['type'] == 'G'
    }.map |$e| { $e['name'] } - ['PUBLIC']

    $users_to_revoke.each |$user| {
      $unique = db2_secured::random_id(6)
      resource_value { "Db2_user[${instance}/${database}/${user}]revoked/${unique}":
        add_value      => $right,
        allow_create   => true,
        allow_redefine => true,
      }
    }
    $groups_to_revoke.each |$group| {
      $unique = db2_secured::random_id(6)
      resource_value { "Db2_group[${instance}/${database}/${group}]revoked/${unique}":
        add_value      => $right,
        allow_create   => true,
        allow_redefine => true,
      }
    }
  }
}
