#
# See the file "LICENSE" for the full license governing this code.
#
#
# Ensure only listed users are member of the specfied group
#
#
define db2_secured::internal::secure_group (
  Array[String[1]]  $list,
  String[1]         $default_group,
) {
  $elements  = $title.split('/')
  $instance  = $elements[0]
  $database  = $elements[1]
  $parameter = $elements[2]

  if  $facts['db2_instances'] {
    $current_group = $facts['db2_instances'][$instance][$parameter]
    if $current_group == undef {
      $group = $default_group
    } else {
      $group = $current_group
    }

    resource_value { "Db2_instance[${instance}]${parameter}":
      allow_create   => true,
      allow_redefine => true,
      value          => $group,
    }

    unless defined(Package[libuser]) {
      package { 'libuser':
        ensure => 'present',
      }
    }

    unless defined(Group[$group]) {
      group { $group:
        ensure          => 'present',
        members         => $list,
        auth_membership => true,
      }
    }
  } else {
    warning "Skipping this control until 'db2_instances' fact is filled"
  }
}
